<?php

/**
 * OlarkchatRulesConfigMapper.php
 *
 *
 * @method Olarkchat_Models_Mappers_OlarkchatRulesConfigMapper  getInstance()   getInstance()   Returns an instance of itself
 * @method Zend_Db_Table    getDbTable()    getDbTable()    Returns an instance of DbTable
 */
class Olarkchat_Models_Mappers_OlarkchatRulesConfigMapper extends Application_Model_Mappers_Abstract
{

    protected $_model = 'Olarkchat_Models_Models_OlarkchatRulesConfigModel';

    protected $_dbTable = 'Olarkchat_Models_Dbtables_OlarkchatRulesConfigDbTable';

    /**
     * Save lead note model to DB
     * @param $model Olarkchat_Models_Models_OlarkchatRulesConfigModel
     * @return Olarkchat_Models_Models_OlarkchatRulesConfigModel
     */
    public function save($model)
    {
        if (!$model instanceof $this->_model) {
            $model = new $this->_model($model);
        }

        $data = array(
            'rule_id' => $model->getRuleId(),
            'field_name' => $model->getFieldName(),
            'rule_comparison_operator' => $model->getRuleComparisonOperator(),
            'field_value' => $model->getFieldValue()
        );

        $id = $model->getId();
        if (!empty($id)) {
            $where = $this->getDbTable()->getAdapter()->quoteInto('id = ?', $id);
            $this->getDbTable()->update($data, $where);
        } else {
            $id = $this->getDbTable()->insert($data);
            $model->setId($id);
        }

        return $model;
    }

    /**
     * get rule fields
     * @param int $ruleId rule id
     * @return array
     */
    public function getFieldsByRuleId($ruleId)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('plorc.rule_id = ?', $ruleId);

        $select = $this->getDbTable()->getAdapter()->select()->from(array('plorc' => 'plugin_olarkchat_rules_config'),
            array('plorc.field_name', 'plorc.id', 'plorc.rule_comparison_operator', 'plorc.field_value'))
            ->where($where)->order('plorc.field_name');

        return $this->getDbTable()->getAdapter()->fetchAssoc($select);
    }

    /**
     * Delete by rule id
     *
     * @param int $ruleId rule id
     * @return int
     */
    public function deleteByRuleId($ruleId)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('rule_id = ?', $ruleId);

        return $this->getDbTable()->getAdapter()->delete('plugin_olarkchat_rules_config', $where);
    }

    /**
     * Delete form rules config record
     *
     * @param int $id config id
     * @return mixed
     * @throws Exception
     */
    public function delete($id)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('id = ?', $id);

        return $this->getDbTable()->getAdapter()->delete('plugin_olarkchat_rules_config', $where);

    }

}
