export const saveConfigData = ({commit, state, dispatch}, payload) => {
    showLoader();
    return new Promise((resolve, reject) => {
        $.ajax({
            'url': $('#website_url').val() + 'api/olarkchat/rules/',
            'type': 'POST',
            'dataType': 'json',
            'data': {
                'secureToken' : $('#olark-chat-rules-config-token').val(),
                'rule_name' :  payload.ruleName,
                'fieldsData':payload.fieldsData,
                'actionsData': payload.actionsData
            }
        }).done(async function (response) {
            hideLoader();
            if (response.status === 'error') {
                resolve(response);
            } else {
                resolve(response);
            }

        }).fail(async function(response){
            hideLoader();
            resolve({ name: 'login', 'message': 'Please re-login'});
        });
    });
}

export const updateConfigData = ({commit, state, dispatch}, payload) => {
    showLoader();
    return new Promise((resolve, reject) => {
        $.ajax({
            'url': $('#website_url').val() + 'api/olarkchat/rules/',
            'type': 'PUT',
            'dataType': 'json',
            'data': JSON.stringify({
                'secureToken' : $('#olark-chat-rules-config-token').val(),
                'rule_name' :  payload.ruleName,
                'fieldsData':payload.fieldsData,
                'actionsData': payload.actionsData,
                'id' : payload.ruleId
            })
        }).done(async function (response) {
            hideLoader();
            if (response.status === 'error') {
                resolve(response);
            } else {
                resolve(response);
            }

        }).fail(async function(response){
            hideLoader();
            resolve({ name: 'login', 'message': 'Please re-login'});
        });
    });
}

export const deleteConfigRecord = ({commit, state, dispatch}, payload) => {
        showLoader();
        return new Promise((resolve, reject) => {
            $.ajax({
                'url': $('#website_url').val() + 'api/olarkchat/rules/id/' + payload.id+'/secureToken/'+ $('#olark-chat-rules-config-token').val(),
                'type': 'DELETE',
                'dataType': 'json'
            }).done(async function (response) {
                hideLoader();
                if (response.status === 'error') {
                    resolve(response);
                } else {
                    resolve(response);
                }

            }).fail(async function (response) {
                hideLoader();
                resolve({name: 'login', 'message': 'Please re-login'});
            });
        });
}

export const getConfigSavedData = ({commit, state, dispatch}, payload) => {
    showLoader();

    return new Promise((resolve, reject) => {
        $.ajax({
            'url': $('#website_url').val()+'api/olarkchat/rules/',
            'type': 'GET',
            'dataType': 'json',
            'data': {
                'limit': state.pagination.olarkChatConfig.itemsPerPage,
                'offset': (state.pagination.olarkChatConfig.currentPage - 1) * state.pagination.olarkChatConfig.itemsPerPage
            }
        }).done(async  function(response){
            hideLoader();
            if (response.status !== 'error') {
                commit('setPaginationData', {olarkChatConfig: {totalItems: response.olarkChatData.totalRecords}});
                commit('setConfigDataInfo', response.olarkChatData.data);
                commit('setConfigScreenInfo', response.olarkChatData.configData);
                resolve(response);
            } else {
                resolve({ name: 'login', 'message': 'Please re-login'});
            }
        }).fail(async function(response){
            resolve({ name: 'login', 'message': 'Please re-login'});
        });
    });
}

export const getRuleConfig = ({commit, state, dispatch}, payload) => {
    showLoader();

    return new Promise((resolve, reject) => {
        $.ajax({
            'url': $('#website_url').val()+'api/olarkchat/rules/',
            'type': 'GET',
            'dataType': 'json',
            'data': {
                'id': payload.ruleId
            }
        }).done(async  function(response){
            hideLoader();
            if (response.status !== 'error') {
                commit('setConfigScreenInfo', response.olarkChatData.configData);
                resolve(response);
            } else {
                resolve({ name: 'login', 'message': 'Please re-login'});
            }
        }).fail(async function(response){
            resolve({ name: 'login', 'message': 'Please re-login'});
        });
    });
}
